/*
    WOCFS - Write-Only enCrypted File System
    Copyright (C) 2011, Michael Rao

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
     any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <string>
using namespace std;
#include <regex.h>


#define A_UNLINK 1
#define A_RENAME 2
#define A_CREATE 4
#define A_MKDIR 8
#define A_RMDIR 16
#define A_TRUNC 32
#define A_ORDWR 64 //OK if open with O_RDWR, but fails if read()
#define A_FINISHONRELEASE 128
#define A_FAKEREAD 256

#define A_P_UNLINK 1024
#define A_P_RENAME 2048
#define A_P_TRUNC 4096
#define A_P_SYMLNK 8192
#define A_P_CREATE 16384

#define POPT_MASK 1
#define POPT_BOOL 1

struct optexpr_t {
  optexpr_t() {regex=NULL;}
  string expr;
  regex_t *regex;
};

struct mopt_t {
  long long m0,m1;
  long long to,mb;
  mopt_t() {
    m0=m1=0;
    to=mb=-2;
  }
  void print() const;
};

extern string o2str(long long o);
extern bool f2o(const char *arg, mopt_t &o);
extern bool vv2o(const char *arg, const char *v, mopt_t &o);

struct opttree_t {
  struct mopt_t opt;
  opttree_t() {
    yes=no=next=NULL;
  }

  optexpr_t test;

  opttree_t *yes;
  opttree_t *no;
  
  opttree_t *next;
};

typedef long long ll_t;

struct opt_t {
  ll_t opt;
  ll_t timeout;
  ll_t maxbuffer;
  void apply(const mopt_t &m) {
    opt|=m.m1;
    opt&=~m.m0;
    if(m.to>=-1) timeout=m.to;
    if(m.mb>=-1) maxbuffer=m.mb;
  }
};

extern opt_t default_opts;

extern opttree_t *opttree_root;

extern bool readopts(const char *fn);
extern void compregex(opttree_t *t) ;
extern void getopt_(opttree_t *t,const char *path, opt_t &o) ;
extern ll_t getopt(const char *path) ;


